#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  int ext;
  int branch=18;
  int crate1=2;
  int crate,slot,subad,function,qres;
  

  int return_status = CAM_S_SUCCESS;
  unsigned short dataw[2]={0,0};
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */

  int iloop=0;
  
 	

 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
  ccci(ext,0);


    slot=12; subad=1; function=17; dataw[0]=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Enable camac mode : qres=%d data=%X \n", qres, dataw[0]);

    slot=12; subad=1; function=1; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("get mode register contents : qres=%d data=%X \n", qres, dataw[0]);

    slot=12; subad=0; function=17; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Set memory address : qres=%d data=%X \n", qres, dataw[0]);

    for ( iloop=0; iloop<1024; iloop++) {
       slot=12; subad=0; function=0; dataw[0]=0;
       cdreg(&ext,branch,crate1,slot,subad);
       cssa(function,ext,dataw,&qres);
       printf("Read and increment at current address: %d qres=%d data=%X \n", iloop,qres, dataw[0]);
    }
 
 
    printf("\n\n***** Normal END *****\n\n");

    return 0;
}
