#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  int ext;
  int branch=18;
  int crate1=2;
  int crate,slot,subad,function,temp,qres;
  

  int return_status = CAM_S_SUCCESS;
  unsigned short dataw[2]={0,0};
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	

 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
  /*  ccci(ext,0); */


	printf("Program assumes ADC1 is in crate=2 slot=8\n");
  /****************** SET UP 1st Ortec AD411 ADC ***********************/
  /*	0x5F00 = 1001 1111 0000 0000
						1801	CB01
	---					----
	B16 =0 => Overflow-suppresion		0	1
	B15 =1 => Camac Lam enable		0	1
	B14	no used				0	0
	B13 =1 => Singles mode			1	0
	---
	B12 =1 => Master Gate ignored		1	1
	B11 =1 => Local Gate ignored		0	0
	B10 =1 => Camac readout enabled		0	1
	B9  =0 => Zero-suppression 		0	1
        ----					
	b1-b8	virtual address			1	1
   */

    printf("Read current values for ADC1:\n");
    slot=8; subad=0; function=0; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Control Register read: qres=%d data=%X \n", qres, dataw[0]);
 
    slot=8; subad=0; function=24; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Set ENABLE/DISABLE flag to DISABLE: qres=%d data=%X \n", qres, dataw[0]);
 
    slot=8; subad=0; function=26; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Set ENABLE/DISABLE flag to ENABLE: qres=%d data=%X \n", qres, dataw[0]);
 
    slot=8; subad=0; function=27; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Status of ENABLE/DISABLE flag: qres=%d data=%X \n", qres, dataw[0]);
 
    slot=8; subad=0; function=24; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Set ENABLE/DISABLE flag to DISABLE: qres=%d data=%X \n", qres, dataw[0]);

	sleep(1);
 
    slot=8; subad=0; function=8; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Test LAM: qres=%d data=%X \n", qres, dataw[0]);
 
    slot=8; subad=0; function=2; dataw[0]=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(function,ext,dataw,&qres);
    printf("Read ADC converted: qres=%d data=%X \n", qres, dataw[0]);
 
    printf("\n Initializing ADC1");

  /* Clear module */
    slot=8; subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);

  /* Write to control register and read back  */
    dataw[0]=0x1801;    
    dataw[0]=0xCB01;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC1 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 LLD: 0x%x", temp & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 ULD: 0x%x", dataw[0] & 0xFF);	

  /* Read the input dc-offset */
    subad=2;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 DCoffSet: 0x%x", dataw[0] & 0xFF);	
    printf("\n");

	printf("Program assumes ADC2 is in crate=2 slot=3\n");
  /****************** SET UP 2nd Ortec AD411 ADC ***********************/
 
    printf("\n Initializing ADC2");

  /* Clear module */
    slot=3; subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);

  /* Write to control register and read back  */
    dataw[0]=0x1402;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC2 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 LLD: 0x%x", dataw[0] & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 ULD: 0x%x", dataw[0] & 0xFF);	
    printf("\n");


    printf("\n\n***** Normal END *****\n\n");

    return 0;
}
